#include <stdio.h>
#include <stdint.h>

#include "board.h"
#include "periph/gpio.h"
#include "ztimer.h"

static int static_glob = 10;
const int const_glob = 20;

void button_irq_handler(void *arg) {
  (void)arg;
  int a = 10;
  static int static_a = 20;
  printf("IRQ handler local var addr: %p\n", &a);
  printf("IRQ handler static var addr: %p\n", &static_a);
}

int main(void) {
  static int static_a = 20;
  int a = 10;
  
  gpio_init_int(BTN0_PIN, GPIO_IN_PU, GPIO_FALLING, button_irq_handler, NULL);

  printf("Main local var addr: %p\n", &a);
  printf("Main statuc var addr: %p\n", &static_a);

  printf("Static var addr: %p\n", &static_glob);
  printf("Const global var addr: %p\n, &const_glob");

  for (;;) {
    ztimer_sleep(ZTIMER_USEC, US_PER_SEC);
  }
}

